import time
from time import sleep
import math 

import RPi.GPIO as GPIO # Import Raspberry Pi GPIO library
GPIO.setwarnings(False) # Ignore warning for now
GPIO.setmode(GPIO.BOARD) # Use physical pin numbering
GPIO.setup(10, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)

'''
odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
'''
odrv0.axis0.controller.config.vel_limit = 60
odrv0.axis0.motor.config.current_lim = 50
odrv0.axis0.controller.config.pos_gain = 90
odrv0.axis0.controller.config.vel_gain = 0.6
odrv0.axis0.controller.config.vel_integrator_gain = 0
odrv0.axis0.trap_traj.config.accel_limit = 20
odrv0.axis0.trap_traj.config.decel_limit = 20
odrv0.axis0.trap_traj.config.vel_limit = 42
'''
odrv0.axis0.requested_state = AXIS_STATE_IDLE
odrv0.axis0.requested_state = AXIS_STATE_STARTUP_SEQUENCE
odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL

exec(open('r2.py').read())
odrv0.axis0.requested_state = AXIS_STATE_IDLE
'''

toggle = False 
hoyTeller = 0 

dT = 0.002 # samplings intervall
t = 0     # tid
f = 0.8   # Hz for sinus eksemplet   
while 1 == 1:
  time.sleep(dT)
  if GPIO.input(10) == GPIO.HIGH:  
    hoyTeller = hoyTeller + 1
    if hoyTeller > 100:       
      print('trykk %d\n', toggle) 
      toggle = not toggle  
      hoyTeller = -1000  
      '''
      if toggle == True:
        odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
      else:
        odrv0.axis0.requested_state = AXIS_STATE_IDLE
      '''
  if GPIO.input(10) == GPIO.LOW:
    hoyTeller = 0   
    
  if toggle == True:  
    t = t + dT   
    y = (math.sin(2*math.pi*f*t)+1) / 6 + 0.32
    odrv0.axis0.controller.input_pos = y
